<?php

namespace App\Livewire\Studio\Master\Outlet;

use App\Enums\Day;
use App\Livewire\Forms\Studio\Master\OutletForm;
use App\Traits\Authorization\WithAuthorization;
use App\Traits\Components\WithToast;
use App\Traits\Outlet\WithFacilityHandler;
use Illuminate\Contracts\View\View;
use Livewire\Attributes\Title;
use Livewire\Component;

#[Title('Tambah Outlet')]
class Create extends Component
{
    use WithAuthorization, WithFacilityHandler, WithToast;

    public OutletForm $form;

    public array $days = [];

    public function mount(): void
    {
        $this->form->opening_hours = collect(Day::cases())
            ->mapWithKeys(fn (Day $day) => [
                $day->value => [
                    'open_time' => null,
                    'close_time' => null,
                ],
            ])
            ->toArray();

        $this->days = Day::cases();
    }

    public function save(): void
    {
        $this->canOrAbort('create outlet');

        $this->form->store();

        $this->redirectRoute('studio.master.outlet.index', [
            'notification' => 'Outlet berhasil ditambahkan.',
        ], navigate: true);
    }

    public function render(): View
    {
        return view('livewire.studio.master.outlet.form', [
            'pageTitle' => 'Tambah Outlet',
        ]);
    }
}
